<?php

/**
 * 
 * @version $Id: initiatesubmap.php,v 2.4.1.1 2003/12/12 22:24:21 fredo Exp $
 * @copyright 2003 
 * This file is part of MAP feature for BB4 
 * initiate for submap feature
 */
// $DEBUG = 1;
function DEBUGPRINT( $texte )
{
  Global $DEBUG;
  if ( $DEBUG ) {
    $filename = "error_map_log.txt";
    $ff = fopen( $filename, 'a+' );
    if ( is_writable( $filename ) ) {
      // write the file
      if ( ! @fwrite( $ff, "Error Message: " . date( "d-m-Y G:i:s" ) . ":" . $texte . "\n" ) ) {
        // if we are unable to write for any reason
        echo ( "<br>Error Message: " . $texte . "<br>\n" );
      } 
    } else {
      // if the file does not exist or is not writable..
      echo ( "<br>Error Message: " . $texte . "<br>\n" );
    } 
    fclose( $ff );
  } 
} 
//error_reporting( E_ERROR | E_WARNING | E_PARSE | E_CORE_ERROR | E_CORE_WARNING | E_ALL );
error_reporting(E_ERROR);
$GlobalParam = parse_ini_file( "globalmap.cfg" );
$val = extract( $GlobalParam );
if ( $val == 0 ) {
  die( "Error while reading file globalmap.cfg" );
} 
function VARset_global( &$var, $name )
{
  if ( ! empty( $var ) ) {
    return;
  } 
  if ( ! empty( $_GET[$name] ) ) {
    $var = trim( $_GET[$name] );
  } else if ( ! empty( $_POST[$name] ) ) {
    $var = trim( $_POST[$name] );
  } else {
    $var = "";
  } 
} 
if ( ! isset( $CurrentFileMap ) ) {
  $CurrentFileMap = $filemapcfg;
} 
// now load the map configuration
$GlobalHost = array();
$GlobalService = array();

function Add_GlobalServices( $arrayofservice )
{
  Global $GlobalService;
  $temp = array_merge( $GlobalService, $arrayofservice );
  $GlobalService = array_unique( $temp );
} 

function Read_File_Line( $filename )
{
  if ( ! file_exists( $filename ) ) {
    die( "Cannot open file $filename!" );
  } 
  $lines = file( $filename );
  $result = array();
  foreach ( $lines as $line ) {
    $line = trim( $line );
    if ( ( $line == "" ) || ( $line{0} == ";" ) || ( $line{0} == "#" ) ) {
      // comment or empty line
      continue;
    } 
    $result[] = $line;
  } 
  return $result;
} 

$lines = Read_File_Line( $bbmap."map/" . $CurrentFileMap );
foreach ( $lines as $line ) {
  $pos = strpos( $line, "=" );
  $property = trim( substr( $line, 0, $pos ) );
  $val = trim( substr( $line, $pos + 1 ) );
  if ( ( $property == "" ) || ( $val == "" ) ) {
    continue;
  } 
  switch ( $property ) {
  case 'SERVICES':
    Add_GlobalServices( explode( ",", $val ) );
    break;
  case 'VAR':
    list( $name, $value ) = explode( ":", $val );
    $$name = $value;
    break;
  case 'HOST':
  case 'HOSTGROUP':
    $hostprop = explode( ":", $val ); 
  // hostname:[commalistparenthost_with_!list_of_color_width_text]:x:y:pict:[listserv]
  // hostgroupname:[commalistparenthost_with_!list_of_color_width_text]:x:y:pict:listhost:[listserv]
  // list is name separate by , (no blank space)
    $host = array( $hostprop[0], $hostprop[1], $property,
		   $hostprop[2], $hostprop[3], $hostprop[4] ); 
  // hostname or hostgroupname, parent hostname list and other info, HOSTGROUP or HOST,
  // x, y, picture
    $temp = explode(",", $host[1]);
    $newparents = array();
    foreach ($temp as $parent) {
      $newparents[] = explode("!", $parent);
    }
    $host[1] = $newparents;
    if ( $property == "HOSTGROUP" ) {
      $host[6] = explode( ",", $hostprop[5] ); // list of hosts in group
      if ( ! isset( $hostprop[6] ) ) {
	$host[7] = ""; // empty service list
      } else {
	$host[7] = explode( ",", $hostprop[6] ); // list of service  
	// NO          Add_GlobalServices($host[7]);
      } 
    } else {
      $host[6] = ""; // empty group list
      if ( ! isset( $hostprop[5] ) ) {
	$host[7] = ""; // empty service list
      } else {
	$host[7] = explode( ",", $hostprop[5] ); // list of service  
	// NO          Add_GlobalServices($host[7]);
      } 
    } 
    $GlobalHost[$hostprop[0]] = $host;
    break;
  case 'SUBMAP': 
    // submapname:[commalistparenthost_with_!list_of_color_width_text]:x:y:pict
    $hostprop = explode( ":", $val );
    $host = array( $hostprop[0], $hostprop[1], $property,
		   $hostprop[2], $hostprop[3], $hostprop[4] );
    $temp = explode(",", $host[1]);
    $newparents = array();
    foreach ($temp as $parent) {
      $newparents[] = explode("!", $parent);
    }
    $host[1] = $newparents;
    $submapname = $hostprop[0];
    if ($userpasswd != "") {
      $access = $userpasswd."@";
    } else $access = "";
    $listmap = file( "http://" . $access . $_SERVER['SERVER_NAME'] . "/" . $bbwebmap . "/statussubmap.php?submap=$submapname" ); 
    // return [listhost, globalstatus, redhosts,...,greenhosts]
    if ( trim( $listmap[0] ) != "" ) {
      $host[6] = explode( ",", trim( $listmap[0] ) );
      $host[8] = array( trim( $listmap[1] ) );
      for ( $i = 2; $i <= 7 ; $i++ ) {
	if ( trim( $listmap[$i] ) != "" )
	  $host[8][$i-1] = explode( ",", trim( $listmap[$i] ) );
	else
	  $host[8][$i-1] = "";
      } 
    } else {
      $host[6] = array();
      $host[8] = array( 3, "", "", "", "", "", "" );
    } 
    $GlobalHost[$hostprop[0]] = $host;
    break;
  default:
  } // switch else do nothing
} // end foreach lines
// verify global services list
if ( count( $GlobalService ) == 0 ) {
  require( 'servlist.php' );
  $GlobalService = $GlobalServList;
} 

// set order priority for color management
// $aordercolor = explode(",", $ordercolor);
// $revordercolor = array_flip($aordercolor);
$GlobalStatus = 6; //green : default
// $GlobalStatus = $aordercolor[5];
// $DEBUG=1;
// DEBUGPRINT(print_r($aordercolor,true).print_r($revordercolor,true).$GlobalStatus);
// $DEBUG=0;

function Get_Colors( $hostname, $services )
{
  Global $statusreturn;
  if ( strpos( $statusreturn, "fullstatusreturn.sh" ) != false ) {
    // hostname only : fullstatusreturn
    $result = trim( shell_exec( $statusreturn . " " . $hostname ) );
    if ( $result == "" ) {
      $output = array( 3 );
      $output[1] = $output[2] = $output[3] = $output[4] = $output[5] = $output[6] = "NaN";
      return $output;
    } 
    $output2 = explode( ":", $result );
    $output = array();
    $output[0] = 6;
    for ( $i = 1; $i <= 6 ; $i++ ) {
      if ( trim( $output2[$i] ) != "" ) {
        $servtemp = explode( " ", trim( $output2[$i] ) );
        $servtemp2 = array();
        foreach ( $servtemp as $serv ) {
          $name = trim( $serv );
          if ( $name != "" && in_array( $name, $services ) ) {
            $servtemp2[] = $name;
          } 
        } 
        if ( count( $servtemp2 ) > 0 ) {
          $output[$i] = $servtemp2;
          if ( $output[0] > $i )
            $output[0] = $i;
        } else
          $output[$i] = "";
      } else {
        $output[$i] = "";
      } 
    } 
    return $output;
  } else { // hostname services...
    $output = trim( shell_exec( $statusreturn . " " . $hostname . " " . implode( ":", $services ) ) );
    if ( trim( $output ) == "" ) {
      $output = array( 3 );
      $output[1] = $output[2] = $output[3] = $output[4] = $output[5] = $output[6] = "NaN";
      return $output; // no information ?
    } 
    $output2 = explode( ":", $output );
    for ( $i = 1; $i <= 6 ; $i++ ) {
      if ( trim( $output2[$i] ) == "" ) {
        $output2[$i] = "";
      } else
        $output2[$i] = explode( ",", $output2[$i] );
    } 
    return $output2;
  } 
} 
// compute colors
$listofservice = array();
foreach ( $GlobalHost as $host ) {
  if ( $host[2] == "HOST" ) {
    if ( ( ! is_array( $host[7] ) ) && ( count( $GlobalService ) == 0 ) ) {
      // no restriction
      $listofservice = array();
    } else if ( ! is_array( $host[7] ) ) { // global restriction
      $listofservice = $GlobalService;
    } else { // local restriction
      $listofservice = $host[7];
    } 
    $host[8] = Get_Colors( $host[0], $listofservice );
    if ( $GlobalStatus > $host[8][0] ) {
      $GlobalStatus = $host[8][0];
    } 
  } else if ( $host[2] == "HOSTGROUP" ) {
    $groupcolor = 6;
    $grouphost = array( $groupcolor );
    for ( $i = 1; $i <= 6 ; $i++ ) {
      $grouphost[$i] = array();
    } 
    if ( ( ! is_array( $host[7] ) ) && ( count( $GlobalService ) == 0 ) ) {
      // no restriction
      $listofservice = array();
    } else if ( ! is_array( $host[7] ) ) { // global restriction
      $listofservice = $GlobalService;
    } else { // local restriction
      $listofservice = $host[7];
    } 

    foreach ( $host[6] as $subhost ) {
      $localhost = Get_Colors( $subhost, $listofservice );
      if ( $groupcolor > $localhost[0] ) {
        $groupcolor = $localhost[0];
      } 
      $grouphost[$localhost[0]][] = $subhost;
    } 
    $grouphost[0] = $groupcolor;
    for ( $i = 1 ; $i <= 6 ; $i++ ) {
      if ( count( $grouphost[$i] ) == 0 ) {
        unset( $grouphost[$i] );
        $grouphost[$i] = "";
      } 
    } 
    $host[8] = $grouphost;
    if ( $GlobalStatus > $groupcolor ) {
      $GlobalStatus = $groupcolor;
    } 
  } // End HOSTGROUP
  else { // SUBMAP
    if ( $GlobalStatus > $host[8][0] ) {
      $GlobalStatus = $host[8][0];
    } 
  } 
  $GlobalHost[$host[0]] = $host;
} 

if ( $DEBUG ) {
  echo "Global END: $GlobalStatus <br>\n<PRE>";
  print_r( $GlobalHost );
  echo "</PRE><br>";
} 

?>
