#!/usr/bin/perl
# @version $Id: fullstatusreturn.sh,v 2.5 2003/12/12 22:39:05 fredo Exp $
# @copyright 2003 
# call : fullstatusreturn.sh hostname
# return global status (red,yellow,purple,blue,clear,green) as (1-6)
# follow by each service by status (1-6)
# default : global status = first from red,yellow,purple,blue,clear,green in this order
# change if needed
my $bb = "/var/hobbit/server/bin/bb";
my $server = "localhost";
my %status;
my $host = $ARGV[0];
$host =~ s/\./,/g;
my @stats = split(/\W/,$ARGV[1]);
foreach my $stat (@stats) {
	my $query = "$bb $server \"query $host.$stat\"";
	my ($color) =  (`$query` =~ /^(\w+)/);
	push @{ $status{$color}}, $stat;
}
my $return = join(":",6,join(",",@{$status{red}}),
			join(",",@{$status{yellow}}),
			join(",",@{$status{purple}}),
			join(",",@{$status{blue}}),
			join(",",@{$status{clear}}),
			join(",",@{$status{green}}));
print $return."\n";
